function Init() {
    parent.initPanel('chrome://chatzilla/content/pref-irc-startup.xul');
    loadList('Scripts');
    loadList('URLs');
}

function loadList(list) {
    var gList = document.getElementById('czInitial' + list);
    
    var prefList = gList.getAttribute("prefvalue");
    
    var items = prefList.split(/\s*;\s*/);
    for (i in items) {
        listAddItem(list, items[i]);
    }
    listUpdateButtons(list);
}

function getIRCDisplayText(url) {
    if (url == "irc:" || url == "irc:/" || url == "irc://") {
        return "Client view";
    } else if (url == "irc:///") {
        return "Default network";
    } else if (params = url.match(/^irc:\/\/\/(.*)$/)) {
        return params[1] + " channel on default network";
    } else if (params = url.match(/^irc:\/\/(.*)\/$/)) {
        return params[1] + " network";
    } else if (params = url.match(/^irc:\/\/(.*)\/(.*)$/)) {
        return params[2] + " channel on " + params[1];
    } else {
        return url;
    }
}

function addScript() {
    var gData = new Object();
    
    window.openDialog(
        "chrome://chatzilla/content/pref-irc-startup-newScript.xul", 
        "czAddScript", "chrome,modal,resizable=no", gData);
    
    if (gData.ok) {
        listAddItem('Scripts', gData.url);
    }
}

function addURL() {
    var gData = new Object();
    
    window.openDialog(
        "chrome://chatzilla/content/pref-irc-startup-newURL.xul", 
        "czAddURL", "chrome,modal,resizable=no", gData);
    
    if (gData.ok) {
        listAddItem('URLs', gData.url);
    }
}

function editURL() {
    var gData = new Object();
    var gList = document.getElementById('czInitialURLs');
    
    var selected = gList.selectedItems[0];
    gData.url = selected.getAttribute("url");
    
    window.openDialog(
        "chrome://chatzilla/content/pref-irc-startup-newURL.xul", 
        "czEditURL", "chrome,modal,resizable=no", gData);
    
    if (gData.ok) {
        selected.setAttribute("label", getIRCDisplayText(gData.url));
        selected.setAttribute("url", gData.url);
    }
}

function listUpdateButtons(list) {
    var gList = document.getElementById('czInitial' + list);
    var gButtonUp = document.getElementById('czUp' + list);
    var gButtonDn = document.getElementById('czDn' + list);
    var gButtonAdd = document.getElementById('czAdd' + list);
    var gButtonEdit = document.getElementById('czEdit' + list);
    var gButtonDel = document.getElementById('czDel' + list);
    
    if (gList.selectedItems && gList.selectedItems.length) {
        if (gButtonEdit) gButtonEdit.removeAttribute("disabled");
        gButtonDel.removeAttribute("disabled");
    } else {
        if (gButtonEdit) gButtonEdit.setAttribute("disabled", "true");
        gButtonDel.setAttribute("disabled", "true");
    }
    if (gList.selectedItems.length == 0 || gList.selectedIndex == 0) {
        gButtonUp.setAttribute("disabled", "true");
    } else {
        gButtonUp.removeAttribute("disabled");
    }
    if (gList.selectedItems.length == 0 
            || gList.selectedIndex == gList.childNodes.length - 1) {
        gButtonDn.setAttribute("disabled", "true");
    } else {
        gButtonDn.removeAttribute("disabled");
    }
}

function listUpdate(list) {
    var gList = document.getElementById('czInitial' + list);
    
    listUpdateButtons(list);
    
    var prefList = "";
    
    for (var item = gList.firstChild; item; item = item.nextSibling) {
        var url = item.getAttribute("url");
        if (prefList) {
            prefList = prefList + "; " + url;
        } else {
            prefList = url;
        }
    }
    gList.setAttribute("prefvalue", prefList);
}

function listAdd(list) {
    if (list == 'Scripts') {
        addScript();
    } else if (list == 'URLs') {
        addURL();
    }
    listUpdate(list);
}

function listEdit(list) {
    if (list == 'URLs') {
        editURL();
    }
    listUpdate(list);
}

function listDelete(list) {
    var gList = document.getElementById('czInitial' + list);
    
    var selected = gList.selectedItems[0];
    gList.removeChild(selected);
    
    listUpdate(list);
}

function listAddItem(list, url) {
    var gList = document.getElementById('czInitial' + list);
    var newItem = document.createElement("listitem");
    
    var label = url;
    if (list == 'URLs') label = getIRCDisplayText(url);
    
    if (list == 'Scripts') newItem.setAttribute("crop", "center");
    newItem.setAttribute("label", label);
    newItem.setAttribute("url", url);
    
    gList.appendChild(newItem);
}

function listMoveUp(list) {
    var gList = document.getElementById('czInitial' + list);
    
    var selected = gList.selectedItems[0];
    var before = selected.previousSibling;
    if (before) {
        before.parentNode.insertBefore(selected, before);
        gList.selectItem(selected);
        gList.ensureElementIsVisible(selected);
    }
    listUpdate(list);
}

function listMoveDown(list) {
    var gList = document.getElementById('czInitial' + list);
    
    var selected = gList.selectedItems[0];
    if (selected.nextSibling) {
        if (selected.nextSibling.nextSibling) {
            gList.insertBefore(selected, selected.nextSibling.nextSibling);
        } else {
            gList.appendChild(selected);
        }
        gList.selectItem(selected);
    }
    listUpdate(list);
}
